///license
//Christian Himpe 2010
//DCM - Dynamic Causal Modelling (forbase.hh)
///*

///guard
#ifndef HH_FORBASE
#define HH_FORBASE
///*

///header
/* class name:	Forbase
 * 
 * description:	base class for forward system sub model
 * 
 * author:		Christian Himpe
 * 
 * notes:		...
 * 
 * todo:        ...
 * 
 * version:		1.0
 */
///*

///declarations
class vector;
class matrix;
///*

///definitions
class Forbase
{
	protected:
		int dim;													//Dimension of Equation
		int paras;														//Number of Parameters
		int index;												//Index of Forward Equation
		vector para;													//Parameter Vector
		matrix cova;													//Covariance Matrix
	public:
		Forbase(int d,int p,int i) : dim(d),paras(p),index(i),para(p,ROW),cova(p,p) { ; };	//Constructor
		virtual ~Forbase() { ; };										//Virtual Destructor
		virtual vector initial() const = 0;								//Virtual Initial Values
		virtual vector righthand(double z,const vector& h) = 0;			//Virtual Righthandside
		virtual double getoutput(double z,const vector& h) const = 0;	//Virtual Compute Output of Current State
		virtual void reset(const vector& f) = 0;						//Virtual Reset Parameters with Given
		int getdim() const { return dim; };								//Get Dimension of Equation
		int getparas() const { return paras; };							//Get Number of Parameters
		vector getpara() const { return para; };						//Get Parameter Vector
		matrix getcova() const { return cova; };						//Get Covariance
};
///*

#endif 
